;; BF AST Transformation and IR Optimizations
;; Jon Simons (simonsj at ccs dot neu dot edu)
;; April, 2008
;; -------------------------------------------------------------------------
;; This file can be included once for obtaining all optimization functions.
;;
;; All optimizations are operations which modify BF IR and return BF IR.
;; See the individual optimization source files for details on what they
;; are and how they work.
;; -------------------------------------------------------------------------
(module ops mzscheme

  ;; After a cursory struggle, can't figure out how to do this in a better
  ;; way...
  
  (require "../bf-ast-to-ir.scm")
  (require "collapse-mults.scm")
  (require "collapse-zeroes.scm")
  (require "dead-loops.scm")
  
  (provide (all-from "../bf-ast-to-ir.scm")
           (all-from "collapse-mults.scm")
           (all-from "collapse-zeroes.scm")
           (all-from "dead-loops.scm"))
  
  )
